﻿Option Explicit On
Option Strict On

Imports System.Threading

Module Mod_Calc
    Private Const WashoutGainDivisor As Double = 27.5
    Private Const WashoutCenterDivisor As Double = 70000
    Private Const CalculateRateMS As Integer = 1

    Public Function EngineIsRunning() As Boolean
        If Calc_Percent_IsRunning = True Or Axis_Calulations_Calc = True Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Function AxisCalcIsRunning() As Boolean
        If Axis_Calulations_Calc = True Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Sub Calculate_Percentges_ON()
        'edit what to turn on here
        Calc_Percent_IsRunning = True
        Calculate_Roll_Percent_ON()
        Calculate_Pitch_Percent_ON()
        Calculate_Heave_Percent_ON()
        Calculate_Yaw_Percent_ON()
        Calculate_Sway_Percent_ON()
        Calculate_Surge_Percent_ON()
    End Sub

    Public Sub Calculate_Percentges_OFF()
        Calc_Percent_IsRunning = False
    End Sub

    Public Function IsAnyOutputRequired() As Boolean
        Dim Inteface As New Mod_NetTools.NetClient.InterfaceAssignments
        Inteface = CType(GameServer.GetInterfaceAssignments1, NetClient.InterfaceAssignments)
        If Inteface._PacketRateMS <> 0 Then
            Return True
        End If
        Inteface = CType(GameServer.GetInterfaceAssignments2, NetClient.InterfaceAssignments)
        If Inteface._PacketRateMS <> 0 Then
            Return True
        End If
        Inteface = CType(GameServer.GetInterfaceAssignments3, NetClient.InterfaceAssignments)
        If Inteface._PacketRateMS <> 0 Then
            Return True
        End If
        Inteface = CType(GameServer.GetInterfaceAssignments4, NetClient.InterfaceAssignments)
        If Inteface._PacketRateMS <> 0 Then
            Return True
        End If
        Inteface = CType(GameServer.GetInterfaceAssignments5, NetClient.InterfaceAssignments)
        If Inteface._PacketRateMS <> 0 Then
            Return True
        End If
        Inteface = CType(GameServer.GetInterfaceAssignments6, NetClient.InterfaceAssignments)
        If Inteface._PacketRateMS <> 0 Then
            Return True
        End If
        Return False
    End Function

    '##################################################################################################
#Region "Roll Calulations"
    Private Calc_Percent_IsRunning As Boolean = False
#Region "Profile and Filters"
    'Roll
    Private Sub Calculate_Roll_Percent_ON()
        Dim trd As Thread = New Thread(AddressOf Roll_Percent_SUB)
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Pitch
    Private Sub Calculate_Pitch_Percent_ON()
        Dim trd As Thread = New Thread(AddressOf Pitch_Percent_SUB)
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Heave
    Private Sub Calculate_Heave_Percent_ON()
        Dim trd As Thread = New Thread(AddressOf Heave_Percent_SUB)
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Yaw
    Private Sub Calculate_Yaw_Percent_ON()
        Dim trd As Thread = New Thread(AddressOf Yaw_Percent_SUB)
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Sway
    Private Sub Calculate_Sway_Percent_ON()
        Dim trd As Thread = New Thread(AddressOf Sway_Percent_SUB)
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Surge
    Private Sub Calculate_Surge_Percent_ON()
        Dim trd As Thread = New Thread(AddressOf Surge_Percent_SUB)
        trd.IsBackground = True
        trd.Start()
    End Sub


    'Roll
    'Main
    Private Roll_Main_ArrayList As New ArrayList()
    Private RollMainOn As Boolean = False
    'Smoothing
    Private Roll_Smoothing_ArrayList As New ArrayList()
    Private RollSmoothingOn As Boolean = False
    'Washout
    Private Roll_OldValue As Double = 0
    Private Roll_Axis As Double = 0
    Private Sub Roll_Percent_SUB()
        Dim Roll_Input As Double
        Dim Roll_Amplified_Used As Double
Start:
        'Get Input 
        Roll_Input = GameServer.GetRoll
        'Adjust Profile Main DOF (Amplifi or De-Amplifi)
        'calulation amplifi or deamplifi
        Roll_Amplified_Used = Roll_Input + (Roll_Input * (GameServer.GetRollEditor * 0.01))
        'Set Output to Pecent Used

        'Main Level Smoothing Filter - old mean-value filter   
        Dim MainEditorValue As Double = GetEditorMain()
        If MainEditorValue <> 0 Then
            If RollMainOn = False Then
                'fill/Clean array list
                Roll_Main_ArrayList.Clear()
                For t = 0 To 100
                    Roll_Main_ArrayList.Add(Roll_Amplified_Used)
                Next
                RollMainOn = True
            End If
            Roll_Main_ArrayList.RemoveAt(0)
            Roll_Main_ArrayList.Insert(CInt(MainEditorValue), Roll_Amplified_Used)
            Dim Main_Output As Double = 0
            For x = 0 To CInt(MainEditorValue)
                Main_Output = Main_Output + CDbl(Roll_Main_ArrayList.Item(x))
            Next
            Main_Output = Main_Output / (MainEditorValue + 1)
            'set now output
            Roll_Amplified_Used = Main_Output
        Else
            RollMainOn = False
        End If

        'Smoothing Filter - old mean-value filter 
        Dim RollEditorValue As Double = GetRollEditorSmothing()
        If RollEditorValue <> 0 Then
            If RollSmoothingOn = False Then
                'fill/Clean array list
                Roll_Smoothing_ArrayList.Clear()
                For t = 0 To 100
                    Roll_Smoothing_ArrayList.Add(Roll_Amplified_Used)
                Next
                RollSmoothingOn = True
            End If

            Roll_Smoothing_ArrayList.RemoveAt(0)
            Roll_Smoothing_ArrayList.Insert(CInt(RollEditorValue), Roll_Amplified_Used)

            Dim Roll_Output As Double = 0
            For x = 0 To CInt(RollEditorValue)
                Roll_Output = Roll_Output + CDbl(Roll_Smoothing_ArrayList.Item(x))
            Next
            Roll_Output = Roll_Output / (RollEditorValue + 1)
            'set now output
            Roll_Amplified_Used = Roll_Output
        Else
            RollSmoothingOn = False
        End If

        'Washout
        Dim RollWashoutEditorValue As Double = GetRollEditorWashoutFilter()
        If RollWashoutEditorValue <> 0 Then
            If Roll_Amplified_Used > 0 And Roll_Amplified_Used > Roll_OldValue Then
                Dim JumpGain As Double = (GetRollMax() / WashoutGainDivisor)
                Roll_Axis = Roll_Axis + ((Roll_Amplified_Used - Roll_OldValue) * JumpGain)
            ElseIf Roll_Amplified_Used < 0 And Roll_Amplified_Used < Roll_OldValue Then
                Dim JumpGain As Double = ((GetRollMin() * -1) / WashoutGainDivisor)
                Roll_Axis = Roll_Axis + ((Roll_Amplified_Used - Roll_OldValue) * JumpGain)
            Else
                'other wise move tward middle
                If Roll_Axis > 0 Then
                    Dim JumpCenter As Double = ((GetRollMax()) / WashoutCenterDivisor)
                    Roll_Axis = Roll_Axis + ((RollWashoutEditorValue * JumpCenter) * -1)
                    If Roll_Axis < 0 Then
                        Roll_Axis = 0
                    End If
                ElseIf Roll_Axis < 0 Then
                    Dim JumpCenter As Double = ((GetRollMin() * -1) / WashoutCenterDivisor)
                    Roll_Axis = Roll_Axis + ((RollWashoutEditorValue * JumpCenter))
                    If Roll_Axis > 0 Then
                        Roll_Axis = 0
                    End If
                End If
            End If
            'save old value
            Roll_OldValue = Roll_Amplified_Used
            'Assign axis out
            Roll_Amplified_Used = Roll_Axis
        End If
        Roll_Percent_Used_SUB(Roll_Amplified_Used)
        Thread.Sleep(CalculateRateMS)
        If Calc_Percent_IsRunning = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub

    'Pitch
    'Main
    Private Pitch_Main_ArrayList As New ArrayList()
    Private PitchMainOn As Boolean = False
    'Smoothing
    Private Pitch_Smoothing_ArrayList As New ArrayList()
    Private PitchSmoothingOn As Boolean = False
    'Washout
    Private Pitch_OldValue As Double = 0
    Private Pitch_Axis As Double = 0
    Private Sub Pitch_Percent_SUB()
        Dim Pitch_Input As Double
        Dim Pitch_Amplified_Used As Double
Start:
        'Get Input 
        Pitch_Input = GameServer.GetPitch
        'Adjust Profile Main DOF (Amplifi or De-Amplifi)
        'calulation amplifi or deamplifi
        Pitch_Amplified_Used = Pitch_Input + (Pitch_Input * (GameServer.GetPitchEditor * 0.01))
        'Set Output to Pecent Used

        'Main Level Smoothing Filter - old mean-value filter   
        Dim MainEditorValue As Double = GetEditorMain()
        If MainEditorValue <> 0 Then
            If PitchMainOn = False Then
                'fill/Clean array list
                Pitch_Main_ArrayList.Clear()
                For t = 0 To 100
                    Pitch_Main_ArrayList.Add(Pitch_Amplified_Used)
                Next
                PitchMainOn = True
            End If
            Pitch_Main_ArrayList.RemoveAt(0)
            Pitch_Main_ArrayList.Insert(CInt(MainEditorValue), Pitch_Amplified_Used)
            Dim Main_Output As Double = 0
            For x = 0 To CInt(MainEditorValue)
                Main_Output = Main_Output + CDbl(Pitch_Main_ArrayList.Item(x))
            Next
            Main_Output = Main_Output / (MainEditorValue + 1)
            'set now output
            Pitch_Amplified_Used = Main_Output
        Else
            PitchMainOn = False
        End If

        'Smoothing Filter - old mean-value filter 
        Dim PitchEditorValue As Double = GetPitchEditorSmothing()
        If PitchEditorValue <> 0 Then
            If PitchSmoothingOn = False Then
                'fill/Clean array list
                Pitch_Smoothing_ArrayList.Clear()
                For t = 0 To 100
                    Pitch_Smoothing_ArrayList.Add(Pitch_Amplified_Used)
                Next
                PitchSmoothingOn = True
            End If
            Pitch_Smoothing_ArrayList.RemoveAt(0)
            Pitch_Smoothing_ArrayList.Insert(CInt(PitchEditorValue), Pitch_Amplified_Used)
            Dim Pitch_Output As Double = 0
            For x = 0 To CInt(PitchEditorValue)
                Pitch_Output = Pitch_Output + CDbl(Pitch_Smoothing_ArrayList.Item(x))
            Next
            Pitch_Output = Pitch_Output / (PitchEditorValue + 1)
            'set now output
            Pitch_Amplified_Used = Pitch_Output
        Else
            PitchSmoothingOn = False
        End If

        'Washout
        Dim PitchWashoutEditorValue As Double = GetPitchEditorWashoutFilter()
        If PitchWashoutEditorValue <> 0 Then
            If Pitch_Amplified_Used > 0 And Pitch_Amplified_Used > Pitch_OldValue Then
                Dim JumpGain As Double = (GetPitchMax() / WashoutGainDivisor)
                Pitch_Axis = Pitch_Axis + ((Pitch_Amplified_Used - Pitch_OldValue) * JumpGain)
            ElseIf Pitch_Amplified_Used < 0 And Pitch_Amplified_Used < Pitch_OldValue Then
                Dim JumpGain As Double = ((GetPitchMin() * -1) / WashoutGainDivisor)
                Pitch_Axis = Pitch_Axis + ((Pitch_Amplified_Used - Pitch_OldValue) * JumpGain)
            Else
                'other wise move tward middle
                If Pitch_Axis > 0 Then
                    Dim JumpCenter As Double = ((GetPitchMax()) / WashoutCenterDivisor)
                    Pitch_Axis = Pitch_Axis + ((PitchWashoutEditorValue * JumpCenter) * -1)
                    If Pitch_Axis < 0 Then
                        Pitch_Axis = 0
                    End If
                ElseIf Pitch_Axis < 0 Then
                    Dim JumpCenter As Double = ((GetPitchMin() * -1) / WashoutCenterDivisor)
                    Pitch_Axis = Pitch_Axis + ((PitchWashoutEditorValue * JumpCenter))
                    If Pitch_Axis > 0 Then
                        Pitch_Axis = 0
                    End If
                End If
            End If
            'save old value
            Pitch_OldValue = Pitch_Amplified_Used
            'Assign axis out
            Pitch_Amplified_Used = Pitch_Axis
        End If
        Pitch_Percent_Used_SUB(Pitch_Amplified_Used)
        Thread.Sleep(CalculateRateMS)
        If Calc_Percent_IsRunning = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub

    'Heave
    'Main
    Private Heave_Main_ArrayList As New ArrayList()
    Private HeaveMainOn As Boolean = False
    'Smoothing
    Private Heave_Smoothing_ArrayList As New ArrayList()
    Private HeaveSmoothingOn As Boolean = False
    'Washout
    Private Heave_OldValue As Double = 0
    Private Heave_Axis As Double = 0
    Private Sub Heave_Percent_SUB()
        Dim Heave_Input As Double
        Dim Heave_Amplified_Used As Double
Start:
        'Get Input 
        Heave_Input = GameServer.GetHeave
        'Adjust Profile Main DOF (Amplifi or De-Amplifi)
        'calulation amplifi or deamplifi
        Heave_Amplified_Used = Heave_Input + (Heave_Input * (GameServer.GetHeaveEditor * 0.01))
        'Set Output to Pecent Used

        'Main Level Smoothing Filter - old mean-value filter   
        Dim MainEditorValue As Double = GetEditorMain()
        If MainEditorValue <> 0 Then
            If HeaveMainOn = False Then
                'fill/Clean array list
                Heave_Main_ArrayList.Clear()
                For t = 0 To 100
                    Heave_Main_ArrayList.Add(Heave_Amplified_Used)
                Next
                HeaveMainOn = True
            End If
            Heave_Main_ArrayList.RemoveAt(0)
            Heave_Main_ArrayList.Insert(CInt(MainEditorValue), Heave_Amplified_Used)
            Dim Main_Output As Double = 0
            For x = 0 To CInt(MainEditorValue)
                Main_Output = Main_Output + CDbl(Heave_Main_ArrayList.Item(x))
            Next
            Main_Output = Main_Output / (MainEditorValue + 1)
            'set now output
            Heave_Amplified_Used = Main_Output
        Else
            HeaveMainOn = False
        End If

        'Smoothing Filter - old mean-value filter 
        Dim HeaveEditorValue As Double = GetHeaveEditorSmothing()
        If HeaveEditorValue <> 0 Then
            If HeaveSmoothingOn = False Then
                'fill/Clean array list
                Heave_Smoothing_ArrayList.Clear()
                For t = 0 To 100
                    Heave_Smoothing_ArrayList.Add(Heave_Amplified_Used)
                Next
                HeaveSmoothingOn = True
            End If
            Heave_Smoothing_ArrayList.RemoveAt(0)
            Heave_Smoothing_ArrayList.Insert(CInt(HeaveEditorValue), Heave_Amplified_Used)
            Dim Heave_Output As Double = 0
            For x = 0 To CInt(HeaveEditorValue)
                Heave_Output = Heave_Output + CDbl(Heave_Smoothing_ArrayList.Item(x))
            Next
            Heave_Output = Heave_Output / (HeaveEditorValue + 1)
            'set now output
            Heave_Amplified_Used = Heave_Output
        Else
            HeaveSmoothingOn = False
        End If

        'Washout
        Dim HeaveWashoutEditorValue As Double = GetHeaveEditorWashoutFilter()
        If HeaveWashoutEditorValue <> 0 Then
            If Heave_Amplified_Used > 0 And Heave_Amplified_Used > Heave_OldValue Then
                Dim JumpGain As Double = (GetHeaveMax() / WashoutGainDivisor)
                Heave_Axis = Heave_Axis + ((Heave_Amplified_Used - Heave_OldValue) * JumpGain)
            ElseIf Heave_Amplified_Used < 0 And Heave_Amplified_Used < Heave_OldValue Then
                Dim JumpGain As Double = ((GetHeaveMin() * -1) / WashoutGainDivisor)
                Heave_Axis = Heave_Axis + ((Heave_Amplified_Used - Heave_OldValue) * JumpGain)
            Else
                'other wise move tward middle
                If Heave_Axis > 0 Then
                    Dim JumpCenter As Double = ((GetHeaveMax()) / WashoutCenterDivisor)
                    Heave_Axis = Heave_Axis + ((HeaveWashoutEditorValue * JumpCenter) * -1)
                    If Heave_Axis < 0 Then
                        Heave_Axis = 0
                    End If
                ElseIf Heave_Axis < 0 Then
                    Dim JumpCenter As Double = ((GetHeaveMin() * -1) / WashoutCenterDivisor)
                    Heave_Axis = Heave_Axis + ((HeaveWashoutEditorValue * JumpCenter))
                    If Heave_Axis > 0 Then
                        Heave_Axis = 0
                    End If
                End If
            End If
            'save old value
            Heave_OldValue = Heave_Amplified_Used
            'Assign axis out
            Heave_Amplified_Used = Heave_Axis
        End If
        Heave_Percent_Used_SUB(Heave_Amplified_Used)
        Thread.Sleep(CalculateRateMS)
        If Calc_Percent_IsRunning = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub

    'Yaw
    'Main
    Private Yaw_Main_ArrayList As New ArrayList()
    Private YawMainOn As Boolean = False
    'Smoothing
    Private Yaw_Smoothing_ArrayList As New ArrayList()
    Private YawSmoothingOn As Boolean = False
    'Washout
    Private Yaw_OldValue As Double = 0
    Private Yaw_Axis As Double = 0
    Private Sub Yaw_Percent_SUB()
        Dim Yaw_Input As Double
        Dim Yaw_Amplified_Used As Double
Start:
        'Get Input 
        Yaw_Input = GameServer.GetYaw
        'Adjust Profile Main DOF (Amplifi or De-Amplifi)
        'calulation amplifi or deamplifi
        Yaw_Amplified_Used = Yaw_Input + (Yaw_Input * (GameServer.GetYawEditor * 0.01))
        'Set Output to Pecent Used

        'Main Level Smoothing Filter - old mean-value filter   
        Dim MainEditorValue As Double = GetEditorMain()
        If MainEditorValue <> 0 Then
            If YawMainOn = False Then
                'fill/Clean array list
                Yaw_Main_ArrayList.Clear()
                For t = 0 To 100
                    Yaw_Main_ArrayList.Add(Yaw_Amplified_Used)
                Next
                YawMainOn = True
            End If
            Yaw_Main_ArrayList.RemoveAt(0)
            Yaw_Main_ArrayList.Insert(CInt(MainEditorValue), Yaw_Amplified_Used)
            Dim Main_Output As Double = 0
            For x = 0 To CInt(MainEditorValue)
                Main_Output = Main_Output + CDbl(Yaw_Main_ArrayList.Item(x))
            Next
            Main_Output = Main_Output / (MainEditorValue + 1)
            'set now output
            Yaw_Amplified_Used = Main_Output
        Else
            YawMainOn = False
        End If

        'Smoothing Filter - old mean-value filter 
        Dim YawEditorValue As Double = GetYawEditorSmothing()
        If YawEditorValue <> 0 Then
            If YawSmoothingOn = False Then
                'fill/Clean array list
                Yaw_Smoothing_ArrayList.Clear()
                For t = 0 To 100
                    Yaw_Smoothing_ArrayList.Add(Yaw_Amplified_Used)
                Next
                YawSmoothingOn = True
            End If
            Yaw_Smoothing_ArrayList.RemoveAt(0)
            Yaw_Smoothing_ArrayList.Insert(CInt(YawEditorValue), Yaw_Amplified_Used)
            Dim Yaw_Output As Double = 0
            For x = 0 To CInt(YawEditorValue)
                Yaw_Output = Yaw_Output + CDbl(Yaw_Smoothing_ArrayList.Item(x))
            Next
            Yaw_Output = Yaw_Output / (YawEditorValue + 1)
            'set now output
            Yaw_Amplified_Used = Yaw_Output
        Else
            YawSmoothingOn = False
        End If

        'Washout
        Dim YawWashoutEditorValue As Double = GetYawEditorWashoutFilter()
        If YawWashoutEditorValue <> 0 Then
            If Yaw_Amplified_Used > 0 And Yaw_Amplified_Used > Yaw_OldValue Then
                Dim JumpGain As Double = (GetYawMax() / WashoutGainDivisor)
                Yaw_Axis = Yaw_Axis + ((Yaw_Amplified_Used - Yaw_OldValue) * JumpGain)
            ElseIf Yaw_Amplified_Used < 0 And Yaw_Amplified_Used < Yaw_OldValue Then
                Dim JumpGain As Double = ((GetYawMin() * -1) / WashoutGainDivisor)
                Yaw_Axis = Yaw_Axis + ((Yaw_Amplified_Used - Yaw_OldValue) * JumpGain)
            Else
                'other wise move tward middle
                If Yaw_Axis > 0 Then
                    Dim JumpCenter As Double = ((GetYawMax()) / WashoutCenterDivisor)
                    Yaw_Axis = Yaw_Axis + ((YawWashoutEditorValue * JumpCenter) * -1)
                    If Yaw_Axis < 0 Then
                        Yaw_Axis = 0
                    End If
                ElseIf Yaw_Axis < 0 Then
                    Dim JumpCenter As Double = ((GetYawMin() * -1) / WashoutCenterDivisor)
                    Yaw_Axis = Yaw_Axis + ((YawWashoutEditorValue * JumpCenter))
                    If Yaw_Axis > 0 Then
                        Yaw_Axis = 0
                    End If
                End If
            End If
            'save old value
            Yaw_OldValue = Yaw_Amplified_Used
            'Assign axis out
            Yaw_Amplified_Used = Yaw_Axis
        End If
        Yaw_Percent_Used_SUB(Yaw_Amplified_Used)
        Thread.Sleep(CalculateRateMS)
        If Calc_Percent_IsRunning = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub

    'Sway
    'Main
    Private Sway_Main_ArrayList As New ArrayList()
    Private SwayMainOn As Boolean = False
    'Smoothing
    Private Sway_Smoothing_ArrayList As New ArrayList()
    Private SwaySmoothingOn As Boolean = False
    'Washout
    Private Sway_OldValue As Double = 0
    Private Sway_Axis As Double = 0
    Private Sub Sway_Percent_SUB()
        Dim Sway_Input As Double
        Dim Sway_Amplified_Used As Double
Start:
        'Get Input 
        Sway_Input = GameServer.GetSway
        'Adjust Profile Main DOF (Amplifi or De-Amplifi)
        'calulation amplifi or deamplifi
        Sway_Amplified_Used = Sway_Input + (Sway_Input * (GameServer.GetSwayEditor * 0.01))
        'Set Output to Pecent Used

        'Main Level Smoothing Filter - old mean-value filter   
        Dim MainEditorValue As Double = GetEditorMain()
        If MainEditorValue <> 0 Then
            If SwayMainOn = False Then
                'fill/Clean array list
                Sway_Main_ArrayList.Clear()
                For t = 0 To 100
                    Sway_Main_ArrayList.Add(Sway_Amplified_Used)
                Next
                SwayMainOn = True
            End If
            Sway_Main_ArrayList.RemoveAt(0)
            Sway_Main_ArrayList.Insert(CInt(MainEditorValue), Sway_Amplified_Used)
            Dim Main_Output As Double = 0
            For x = 0 To CInt(MainEditorValue)
                Main_Output = Main_Output + CDbl(Sway_Main_ArrayList.Item(x))
            Next
            Main_Output = Main_Output / (MainEditorValue + 1)
            'set now output
            Sway_Amplified_Used = Main_Output
        Else
            SwayMainOn = False
        End If

        'Smoothing Filter - old mean-value filter 
        Dim SwayEditorValue As Double = GetSwayEditorSmothing()
        If SwayEditorValue <> 0 Then
            If SwaySmoothingOn = False Then
                'fill/Clean array list
                Sway_Smoothing_ArrayList.Clear()
                For t = 0 To 100
                    Sway_Smoothing_ArrayList.Add(Sway_Amplified_Used)
                Next
                SwaySmoothingOn = True
            End If
            Sway_Smoothing_ArrayList.RemoveAt(0)
            Sway_Smoothing_ArrayList.Insert(CInt(SwayEditorValue), Sway_Amplified_Used)
            Dim Sway_Output As Double = 0
            For x = 0 To CInt(SwayEditorValue)
                Sway_Output = Sway_Output + CDbl(Sway_Smoothing_ArrayList.Item(x))
            Next
            Sway_Output = Sway_Output / (SwayEditorValue + 1)
            'set now output
            Sway_Amplified_Used = Sway_Output
        Else
            SwaySmoothingOn = False
        End If

        'Washout
        Dim SwayWashoutEditorValue As Double = GetSwayEditorWashoutFilter()
        If SwayWashoutEditorValue <> 0 Then
            If Sway_Amplified_Used > 0 And Sway_Amplified_Used > Sway_OldValue Then
                Dim JumpGain As Double = (GetSwayMax() / WashoutGainDivisor)
                Sway_Axis = Sway_Axis + ((Sway_Amplified_Used - Sway_OldValue) * JumpGain)
            ElseIf Sway_Amplified_Used < 0 And Sway_Amplified_Used < Sway_OldValue Then
                Dim JumpGain As Double = ((GetSwayMin() * -1) / WashoutGainDivisor)
                Sway_Axis = Sway_Axis + ((Sway_Amplified_Used - Sway_OldValue) * JumpGain)
            Else
                'other wise move tward middle
                If Sway_Axis > 0 Then
                    Dim JumpCenter As Double = ((GetSwayMax()) / WashoutCenterDivisor)
                    Sway_Axis = Sway_Axis + ((SwayWashoutEditorValue * JumpCenter) * -1)
                    If Sway_Axis < 0 Then
                        Sway_Axis = 0
                    End If
                ElseIf Sway_Axis < 0 Then
                    Dim JumpCenter As Double = ((GetSwayMin() * -1) / WashoutCenterDivisor)
                    Sway_Axis = Sway_Axis + ((SwayWashoutEditorValue * JumpCenter))
                    If Sway_Axis > 0 Then
                        Sway_Axis = 0
                    End If
                End If
            End If
            'save old value
            Sway_OldValue = Sway_Amplified_Used
            'Assign axis out
            Sway_Amplified_Used = Sway_Axis
        End If
        Sway_Percent_Used_SUB(Sway_Amplified_Used)
        Thread.Sleep(CalculateRateMS)
        If Calc_Percent_IsRunning = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub

    'Surge
    'Main
    Private Surge_Main_ArrayList As New ArrayList()
    Private SurgeMainOn As Boolean = False
    'Smoothing
    Private Surge_Smoothing_ArrayList As New ArrayList()
    Private SurgeSmoothingOn As Boolean = False
    'Washout
    Private Surge_OldValue As Double = 0
    Private Surge_Axis As Double = 0
    Private Sub Surge_Percent_SUB()
        Dim Surge_Input As Double
        Dim Surge_Amplified_Used As Double
Start:
        'Get Input 
        Surge_Input = GameServer.GetSurge
        'Adjust Profile Main DOF (Amplifi or De-Amplifi)
        'calulation amplifi or deamplifi
        Surge_Amplified_Used = Surge_Input + (Surge_Input * (GameServer.GetSurgeEditor * 0.01))
        'Set Output to Pecent Used
        'Main Level Smoothing Filter - old mean-value filter   
        Dim MainEditorValue As Double = GetEditorMain()
        If MainEditorValue <> 0 Then
            If SurgeMainOn = False Then
                'fill/Clean array list
                Surge_Main_ArrayList.Clear()
                For t = 0 To 100
                    Surge_Main_ArrayList.Add(Surge_Amplified_Used)
                Next
                SurgeMainOn = True
            End If
            Surge_Main_ArrayList.RemoveAt(0)
            Surge_Main_ArrayList.Insert(CInt(MainEditorValue), Surge_Amplified_Used)
            Dim Main_Output As Double = 0
            For x = 0 To CInt(MainEditorValue)
                Main_Output = Main_Output + CDbl(Surge_Main_ArrayList.Item(x))
            Next
            Main_Output = Main_Output / (MainEditorValue + 1)
            'set now output
            Surge_Amplified_Used = Main_Output
        Else
            SurgeMainOn = False
        End If

        'Smoothing Filter - old mean-value filter 
        Dim SurgeEditorValue As Double = GetSurgeEditorSmothing()
        If SurgeEditorValue <> 0 Then
            If SurgeSmoothingOn = False Then
                'fill/Clean array list
                Surge_Smoothing_ArrayList.Clear()
                For t = 0 To 100
                    Surge_Smoothing_ArrayList.Add(Surge_Amplified_Used)
                Next
                SurgeSmoothingOn = True
            End If
            Surge_Smoothing_ArrayList.RemoveAt(0)
            Surge_Smoothing_ArrayList.Insert(CInt(SurgeEditorValue), Surge_Amplified_Used)
            Dim Surge_Output As Double = 0
            For x = 0 To CInt(SurgeEditorValue)
                Surge_Output = Surge_Output + CDbl(Surge_Smoothing_ArrayList.Item(x))
            Next
            Surge_Output = Surge_Output / (SurgeEditorValue + 1)
            'set now output
            Surge_Amplified_Used = Surge_Output
        Else
            SurgeSmoothingOn = False
        End If

        'Washout
        Dim SurgeWashoutEditorValue As Double = GetSurgeEditorWashoutFilter()
        If SurgeWashoutEditorValue <> 0 Then
            If Surge_Amplified_Used > 0 And Surge_Amplified_Used > Surge_OldValue Then
                Dim JumpGain As Double = (GetSurgeMax() / WashoutGainDivisor)
                Surge_Axis = Surge_Axis + ((Surge_Amplified_Used - Surge_OldValue) * JumpGain)
            ElseIf Surge_Amplified_Used < 0 And Surge_Amplified_Used < Surge_OldValue Then
                Dim JumpGain As Double = ((GetSurgeMin() * -1) / WashoutGainDivisor)
                Surge_Axis = Surge_Axis + ((Surge_Amplified_Used - Surge_OldValue) * JumpGain)
            Else
                'other wise move tward middle
                If Surge_Axis > 0 Then
                    Dim JumpCenter As Double = ((GetSurgeMax()) / WashoutCenterDivisor)
                    Surge_Axis = Surge_Axis + ((SurgeWashoutEditorValue * JumpCenter) * -1)
                    If Surge_Axis < 0 Then
                        Surge_Axis = 0
                    End If
                ElseIf Surge_Axis < 0 Then
                    Dim JumpCenter As Double = ((GetSurgeMin() * -1) / WashoutCenterDivisor)
                    Surge_Axis = Surge_Axis + ((SurgeWashoutEditorValue * JumpCenter))
                    If Surge_Axis > 0 Then
                        Surge_Axis = 0
                    End If
                End If
            End If
            'save old value
            Surge_OldValue = Surge_Amplified_Used
            'Assign axis out
            Surge_Amplified_Used = Surge_Axis
        End If
        Surge_Percent_Used_SUB(Surge_Amplified_Used)
        Thread.Sleep(CalculateRateMS)
        If Calc_Percent_IsRunning = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub
#End Region

#Region "Percent Used Per DOF"
    'Roll
    Private Sub Roll_Percent_Used_SUB(Roll_Incomming As Double)
        Dim trd As Thread = New Thread(Sub() RollPercent(Roll_Incomming))
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Pitch
    Private Sub Pitch_Percent_Used_SUB(Pitch_Incomming As Double)
        Dim trd As Thread = New Thread(Sub() PitchPercent(Pitch_Incomming))
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Heave
    Private Sub Heave_Percent_Used_SUB(Heave_Incomming As Double)
        Dim trd As Thread = New Thread(Sub() HeavePercent(Heave_Incomming))
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Yaw
    Private Sub Yaw_Percent_Used_SUB(Yaw_Incomming As Double)
        Dim trd As Thread = New Thread(Sub() YawPercent(Yaw_Incomming))
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Sway
    Private Sub Sway_Percent_Used_SUB(Sway_Incomming As Double)
        Dim trd As Thread = New Thread(Sub() SwayPercent(Sway_Incomming))
        trd.IsBackground = True
        trd.Start()
    End Sub

    'Surge
    Private Sub Surge_Percent_Used_SUB(Surge_Incomming As Double)
        Dim trd As Thread = New Thread(Sub() SurgePercent(Surge_Incomming))
        trd.IsBackground = True
        trd.Start()
    End Sub


    'Roll
    Private Sub RollPercent(Roll_Incomming As Double)
        Dim Roll_Percent_Out As Double
        If Roll_Incomming > 0 Then
            'need calulation
            Dim RollMax As Double = GameServer.GetRollMax
            If Roll_Incomming > RollMax Then
                Roll_Percent_Out = 1
            Else
                Roll_Percent_Out = Roll_Incomming / RollMax
            End If
        ElseIf Roll_Incomming < 0 Then
            'need calulation
            Dim RollMin As Double = GameServer.GetRollMin
            If Roll_Incomming < RollMin Then
                Roll_Percent_Out = -1
            Else
                Roll_Percent_Out = (Roll_Incomming / RollMin) * -1
            End If
        End If
        'Set Output
        Dim temp As String = Roll_Percent_Out.ToString
        If temp.Contains("E") = True Then
            Roll_Percent_Out = 0
        End If
        GameServer.SetRollPercent(Math.Round(Roll_Percent_Out, 10))
    End Sub

    'Pitch
    Private Sub PitchPercent(Pitch_Incomming As Double)
        Dim Pitch_Percent_Out As Double
        If Pitch_Incomming > 0 Then
            'need calulation
            Dim PitchMax As Double = GameServer.GetPitchMax
            If Pitch_Incomming > PitchMax Then
                Pitch_Percent_Out = 1
            Else
                Pitch_Percent_Out = Pitch_Incomming / PitchMax
            End If
        ElseIf Pitch_Incomming < 0 Then
            'need calulation
            Dim PitchMin As Double = GameServer.GetPitchMin
            If Pitch_Incomming < PitchMin Then
                Pitch_Percent_Out = -1
            Else
                Pitch_Percent_Out = (Pitch_Incomming / PitchMin) * -1
            End If
        End If
        'Set Output
        Dim temp As String = Pitch_Percent_Out.ToString
        If temp.Contains("E") = True Then
            Pitch_Percent_Out = 0
        End If
        GameServer.SetPitchPercent(Math.Round(Pitch_Percent_Out, 10))
    End Sub

    'Heave
    Private Sub HeavePercent(Heave_Incomming As Double)
        Dim Heave_Percent_Out As Double
        If Heave_Incomming > 0 Then
            'need calulation
            Dim HeaveMax As Double = GameServer.GetHeaveMax
            If Heave_Incomming > HeaveMax Then
                Heave_Percent_Out = 1
            Else
                Heave_Percent_Out = Heave_Incomming / HeaveMax
            End If
        ElseIf Heave_Incomming < 0 Then
            'need calulation
            Dim HeaveMin As Double = GameServer.GetHeaveMin
            If Heave_Incomming < HeaveMin Then
                Heave_Percent_Out = -1
            Else
                Heave_Percent_Out = (Heave_Incomming / HeaveMin) * -1
            End If
        End If
        'Set Output
        Dim temp As String = Heave_Percent_Out.ToString
        If temp.Contains("E") = True Then
            Heave_Percent_Out = 0
        End If
        GameServer.SetHeavePercent(Math.Round(Heave_Percent_Out, 10))
    End Sub

    'Yaw
    Private Sub YawPercent(Yaw_Incomming As Double)
        Dim Yaw_Percent_Out As Double
        If Yaw_Incomming > 0 Then
            'need calulation
            Dim YawMax As Double = GameServer.GetYawMax
            If Yaw_Incomming > YawMax Then
                Yaw_Percent_Out = 1
            Else
                Yaw_Percent_Out = Yaw_Incomming / YawMax
            End If
        ElseIf Yaw_Incomming < 0 Then
            'need calulation
            Dim YawMin As Double = GameServer.GetYawMin
            If Yaw_Incomming < YawMin Then
                Yaw_Percent_Out = -1
            Else
                Yaw_Percent_Out = (Yaw_Incomming / YawMin) * -1
            End If
        End If
        'Set Output
        Dim temp As String = Yaw_Percent_Out.ToString
        If temp.Contains("E") = True Then
            Yaw_Percent_Out = 0
        End If
        GameServer.SetYawPercent(Math.Round(Yaw_Percent_Out, 10))
    End Sub

    'Sway
    Private Sub SwayPercent(Sway_Incomming As Double)
        Dim Sway_Percent_Out As Double
        If Sway_Incomming > 0 Then
            'need calulation
            Dim SwayMax As Double = GameServer.GetSwayMax
            If Sway_Incomming > SwayMax Then
                Sway_Percent_Out = 1
            Else
                Sway_Percent_Out = Sway_Incomming / SwayMax
            End If
        ElseIf Sway_Incomming < 0 Then
            'need calulation
            Dim SwayMin As Double = GameServer.GetSwayMin
            If Sway_Incomming < SwayMin Then
                Sway_Percent_Out = -1
            Else
                Sway_Percent_Out = (Sway_Incomming / SwayMin) * -1
            End If
        End If
        'Set Output
        Dim temp As String = Sway_Percent_Out.ToString
        If temp.Contains("E") = True Then
            Sway_Percent_Out = 0
        End If
        GameServer.SetSwayPercent(Math.Round(Sway_Percent_Out, 10))
    End Sub

    'Surge
    Private Sub SurgePercent(Surge_Incomming As Double)
        Dim Surge_Percent_Out As Double
        If Surge_Incomming > 0 Then
            'need calulation
            Dim SurgeMax As Double = GameServer.GetSurgeMax
            If Surge_Incomming > SurgeMax Then
                Surge_Percent_Out = 1
            Else
                Surge_Percent_Out = Surge_Incomming / SurgeMax
            End If
        ElseIf Surge_Incomming < 0 Then
            'need calulation
            Dim SurgeMin As Double = GameServer.GetSurgeMin
            If Surge_Incomming < SurgeMin Then
                Surge_Percent_Out = -1
            Else
                Surge_Percent_Out = (Surge_Incomming / SurgeMin) * -1
            End If
        End If
        'Set Output
        Dim temp As String = Surge_Percent_Out.ToString
        If temp.Contains("E") = True Then
            Surge_Percent_Out = 0
        End If
        GameServer.SetSurgePercent(Math.Round(Surge_Percent_Out, 10))
    End Sub
#End Region
#End Region
    '##################################################################################################

    '##################################################################################################

#Region "Axis Calulations and Axis Limiting"
    Private Roll_Percent As String
    Private Pitch_Percent As String
    Private Heave_Percent As String
    Private Yaw_Percent As String
    Private Sway_Percent As String
    Private Surge_Percent As String
    Private Axis_Calulations_Calc As Boolean = False
    Public Sub Axis_Calulations_ON()
        Axis_Calulations_Calc = True
        'Load AxisAssignments Structure
        My_AxisAssignments = DirectCast(GameServer.GetAxisAssignments, Mod_NetTools.NetClient.AxisAssignments)
        'Axis 1
        Dim trd1 As Thread = New Thread(AddressOf Axis1_Calulations)
        trd1.IsBackground = True
        trd1.Start()

        'Axis 2
        Dim trd2 As Thread = New Thread(AddressOf Axis2_Calulations)
        trd2.IsBackground = True
        trd2.Start()

        'Axis 3
        Dim trd3 As Thread = New Thread(AddressOf Axis3_Calulations)
        trd3.IsBackground = True
        trd3.Start()

        'Axis 4
        Dim trd4 As Thread = New Thread(AddressOf Axis4_Calulations)
        trd4.IsBackground = True
        trd4.Start()

        'Axis 5
        Dim trd5 As Thread = New Thread(AddressOf Axis5_Calulations)
        trd5.IsBackground = True
        trd5.Start()

        'Axis 2
        Dim trd6 As Thread = New Thread(AddressOf Axis6_Calulations)
        trd6.IsBackground = True
        trd6.Start()
    End Sub

    Public Sub Axis_Calulations_OFF()
        Axis_Calulations_Calc = False
    End Sub

#Region "Axis1"
    Private Axis1_Output As Double = 0
    Private Axis1_Value1_Out As Double = 0
    Private Axis1_Value2_Out As Double = 0
    Private Axis1_Value3_Out As Double = 0
    Private Sub Axis1_Calulations()
Start:
        With My_AxisAssignments
            Dim RollPercentUsed As Double = GameServer.GetRollPercent
            Dim PitchPercentUsed As Double = GameServer.GetPitchPercent
            Dim HeavePercentUsed As Double = GameServer.GetHeavePercent
            Dim YawPercentUsed As Double = GameServer.GetYawPercent
            Dim SwayPercentUsed As Double = GameServer.GetSwayPercent
            Dim SurgePercentUsed As Double = GameServer.GetSurgePercent

            'DOF1
            Select Case ._Axis1DOF1
                Case "-"
                    Axis1_Value1_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis1_Value1_Out = RollPercentUsed * (._Axis1PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR1 = True Then
                        Axis1_Value1_Out = Axis1_Value1_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis1_Value1_Out = PitchPercentUsed * (._Axis1PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR1 = True Then
                        Axis1_Value1_Out = Axis1_Value1_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis1_Value1_Out = HeavePercentUsed * (._Axis1PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR1 = True Then
                        Axis1_Value1_Out = Axis1_Value1_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis1_Value1_Out = YawPercentUsed * (._Axis1PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR1 = True Then
                        Axis1_Value1_Out = Axis1_Value1_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis1_Value1_Out = SwayPercentUsed * (._Axis1PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR1 = True Then
                        Axis1_Value1_Out = Axis1_Value1_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis1_Value1_Out = SurgePercentUsed * (._Axis1PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR1 = True Then
                        Axis1_Value1_Out = Axis1_Value1_Out * -1
                    End If
            End Select
            'DOF2
            Select Case ._Axis1DOF2
                Case "-"
                    Axis1_Value2_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis1_Value2_Out = RollPercentUsed * (._Axis1PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR2 = True Then
                        Axis1_Value2_Out = Axis1_Value2_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis1_Value2_Out = PitchPercentUsed * (._Axis1PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR2 = True Then
                        Axis1_Value2_Out = Axis1_Value2_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis1_Value2_Out = HeavePercentUsed * (._Axis1PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR2 = True Then
                        Axis1_Value2_Out = Axis1_Value2_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis1_Value2_Out = YawPercentUsed * (._Axis1PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR2 = True Then
                        Axis1_Value2_Out = Axis1_Value2_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis1_Value2_Out = SwayPercentUsed * (._Axis1PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR2 = True Then
                        Axis1_Value2_Out = Axis1_Value2_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis1_Value2_Out = SurgePercentUsed * (._Axis1PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR2 = True Then
                        Axis1_Value2_Out = Axis1_Value2_Out * -1
                    End If
            End Select
            'DOF3
            Select Case ._Axis1DOF3
                Case "-"
                    Axis1_Value3_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis1_Value3_Out = RollPercentUsed * (._Axis1PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR3 = True Then
                        Axis1_Value3_Out = Axis1_Value3_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis1_Value3_Out = PitchPercentUsed * (._Axis1PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR3 = True Then
                        Axis1_Value3_Out = Axis1_Value3_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis1_Value3_Out = HeavePercentUsed * (._Axis1PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR3 = True Then
                        Axis1_Value3_Out = Axis1_Value3_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis1_Value3_Out = YawPercentUsed * (._Axis1PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR3 = True Then
                        Axis1_Value3_Out = Axis1_Value3_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis1_Value3_Out = SwayPercentUsed * (._Axis1PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR3 = True Then
                        Axis1_Value3_Out = Axis1_Value3_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis1_Value3_Out = SurgePercentUsed * (._Axis1PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis1DIR3 = True Then
                        Axis1_Value3_Out = Axis1_Value3_Out * -1
                    End If
            End Select
            'BUILD Value

            If ._Axis1DOF1 <> "-" Then
                Axis1_Output = Axis1_Value1_Out
            End If
            If ._Axis1DOF2 <> "-" Then
                Axis1_Output = Axis1_Output + Axis1_Value2_Out
            End If
            If ._Axis1DOF3 <> "-" Then
                Axis1_Output = Axis1_Output + Axis1_Value3_Out
            End If

            'Limmit ouput with axis limiter
            Axis1_Output = Axis1_Output * (GameServer.GetAxisLimiting_Axis1 * 0.01)
            'Set output
            Set_Axis1Output(Axis1_Output)
        End With
        'Reset Needed Vars
        Axis1_Output = 0
        'start a new thread
        Thread.Sleep(CalculateRateMS)
        If Axis_Calulations_Calc = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub
#End Region

#Region "Axis2"
    Private Axis2_Output As Double = 0
    Private Axis2_Value1_Out As Double = 0
    Private Axis2_Value2_Out As Double = 0
    Private Axis2_Value3_Out As Double = 0
    Private Sub Axis2_Calulations()
Start:
        With My_AxisAssignments
            Dim RollPercentUsed As Double = GameServer.GetRollPercent
            Dim PitchPercentUsed As Double = GameServer.GetPitchPercent
            Dim HeavePercentUsed As Double = GameServer.GetHeavePercent
            Dim YawPercentUsed As Double = GameServer.GetYawPercent
            Dim SwayPercentUsed As Double = GameServer.GetSwayPercent
            Dim SurgePercentUsed As Double = GameServer.GetSurgePercent

            'DOF1
            Select Case ._Axis2DOF1
                Case "-"
                    Axis2_Value1_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis2_Value1_Out = RollPercentUsed * (._Axis2PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR1 = True Then
                        Axis2_Value1_Out = Axis2_Value1_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis2_Value1_Out = PitchPercentUsed * (._Axis2PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR1 = True Then
                        Axis2_Value1_Out = Axis2_Value1_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis2_Value1_Out = HeavePercentUsed * (._Axis2PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR1 = True Then
                        Axis2_Value1_Out = Axis2_Value1_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis2_Value1_Out = YawPercentUsed * (._Axis2PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR1 = True Then
                        Axis2_Value1_Out = Axis2_Value1_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis2_Value1_Out = SwayPercentUsed * (._Axis2PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR1 = True Then
                        Axis2_Value1_Out = Axis2_Value1_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis2_Value1_Out = SurgePercentUsed * (._Axis2PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR1 = True Then
                        Axis2_Value1_Out = Axis2_Value1_Out * -1
                    End If
            End Select
            'DOF2
            Select Case ._Axis2DOF2
                Case "-"
                    Axis2_Value2_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis2_Value2_Out = RollPercentUsed * (._Axis2PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR2 = True Then
                        Axis2_Value2_Out = Axis2_Value2_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis2_Value2_Out = PitchPercentUsed * (._Axis2PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR2 = True Then
                        Axis2_Value2_Out = Axis2_Value2_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis2_Value2_Out = HeavePercentUsed * (._Axis2PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR2 = True Then
                        Axis2_Value2_Out = Axis2_Value2_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis2_Value2_Out = YawPercentUsed * (._Axis2PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR2 = True Then
                        Axis2_Value2_Out = Axis2_Value2_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis2_Value2_Out = SwayPercentUsed * (._Axis2PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR2 = True Then
                        Axis2_Value2_Out = Axis2_Value2_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis2_Value2_Out = SurgePercentUsed * (._Axis2PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR2 = True Then
                        Axis2_Value2_Out = Axis2_Value2_Out * -1
                    End If
            End Select
            'DOF3
            Select Case ._Axis2DOF3
                Case "-"
                    Axis2_Value3_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis2_Value3_Out = RollPercentUsed * (._Axis2PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR3 = True Then
                        Axis2_Value3_Out = Axis2_Value3_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis2_Value3_Out = PitchPercentUsed * (._Axis2PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR3 = True Then
                        Axis2_Value3_Out = Axis2_Value3_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis2_Value3_Out = HeavePercentUsed * (._Axis2PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR3 = True Then
                        Axis2_Value3_Out = Axis2_Value3_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis2_Value3_Out = YawPercentUsed * (._Axis2PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR3 = True Then
                        Axis2_Value3_Out = Axis2_Value3_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis2_Value3_Out = SwayPercentUsed * (._Axis2PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR3 = True Then
                        Axis2_Value3_Out = Axis2_Value3_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis2_Value3_Out = SurgePercentUsed * (._Axis2PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis2DIR3 = True Then
                        Axis2_Value3_Out = Axis2_Value3_Out * -1
                    End If
            End Select
            'BUILD Value

            If ._Axis2DOF1 <> "-" Then
                Axis2_Output = Axis2_Value1_Out
            End If
            If ._Axis2DOF2 <> "-" Then
                Axis2_Output = Axis2_Output + Axis2_Value2_Out
            End If
            If ._Axis2DOF3 <> "-" Then
                Axis2_Output = Axis2_Output + Axis2_Value3_Out
            End If

            'Limmit ouput with axis limiter
            Axis2_Output = Axis2_Output * (GameServer.GetAxisLimiting_Axis2 * 0.01)
            'Set output
            Set_Axis2Output(Axis2_Output)

        End With
        'Reset Needed Vars
        Axis2_Output = 0
        'start a new thread
        Thread.Sleep(CalculateRateMS)
        If Axis_Calulations_Calc = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub
#End Region

#Region "Axis3"
    Private Axis3_Output As Double = 0
    Private Axis3_Value1_Out As Double = 0
    Private Axis3_Value2_Out As Double = 0
    Private Axis3_Value3_Out As Double = 0
    Private Sub Axis3_Calulations()
Start:
        With My_AxisAssignments
            Dim RollPercentUsed As Double = GameServer.GetRollPercent
            Dim PitchPercentUsed As Double = GameServer.GetPitchPercent
            Dim HeavePercentUsed As Double = GameServer.GetHeavePercent
            Dim YawPercentUsed As Double = GameServer.GetYawPercent
            Dim SwayPercentUsed As Double = GameServer.GetSwayPercent
            Dim SurgePercentUsed As Double = GameServer.GetSurgePercent

            'DOF1
            Select Case ._Axis3DOF1
                Case "-"
                    Axis3_Value1_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis3_Value1_Out = RollPercentUsed * (._Axis3PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR1 = True Then
                        Axis3_Value1_Out = Axis3_Value1_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis3_Value1_Out = PitchPercentUsed * (._Axis3PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR1 = True Then
                        Axis3_Value1_Out = Axis3_Value1_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis3_Value1_Out = HeavePercentUsed * (._Axis3PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR1 = True Then
                        Axis3_Value1_Out = Axis3_Value1_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis3_Value1_Out = YawPercentUsed * (._Axis3PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR1 = True Then
                        Axis3_Value1_Out = Axis3_Value1_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis3_Value1_Out = SwayPercentUsed * (._Axis3PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR1 = True Then
                        Axis3_Value1_Out = Axis3_Value1_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis3_Value1_Out = SurgePercentUsed * (._Axis3PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR1 = True Then
                        Axis3_Value1_Out = Axis3_Value1_Out * -1
                    End If
            End Select
            'DOF2
            Select Case ._Axis3DOF2
                Case "-"
                    Axis3_Value2_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis3_Value2_Out = RollPercentUsed * (._Axis3PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR2 = True Then
                        Axis3_Value2_Out = Axis3_Value2_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis3_Value2_Out = PitchPercentUsed * (._Axis3PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR2 = True Then
                        Axis3_Value2_Out = Axis3_Value2_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis3_Value2_Out = HeavePercentUsed * (._Axis3PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR2 = True Then
                        Axis3_Value2_Out = Axis3_Value2_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis3_Value2_Out = YawPercentUsed * (._Axis3PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR2 = True Then
                        Axis3_Value2_Out = Axis3_Value2_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis3_Value2_Out = SwayPercentUsed * (._Axis3PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR2 = True Then
                        Axis3_Value2_Out = Axis3_Value2_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis3_Value2_Out = SurgePercentUsed * (._Axis3PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR2 = True Then
                        Axis3_Value2_Out = Axis3_Value2_Out * -1
                    End If
            End Select
            'DOF3
            Select Case ._Axis3DOF3
                Case "-"
                    Axis3_Value3_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis3_Value3_Out = RollPercentUsed * (._Axis3PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR3 = True Then
                        Axis3_Value3_Out = Axis3_Value3_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis3_Value3_Out = PitchPercentUsed * (._Axis3PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR3 = True Then
                        Axis3_Value3_Out = Axis3_Value3_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis3_Value3_Out = HeavePercentUsed * (._Axis3PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR3 = True Then
                        Axis3_Value3_Out = Axis3_Value3_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis3_Value3_Out = YawPercentUsed * (._Axis3PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR3 = True Then
                        Axis3_Value3_Out = Axis3_Value3_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis3_Value3_Out = SwayPercentUsed * (._Axis3PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR3 = True Then
                        Axis3_Value3_Out = Axis3_Value3_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis3_Value3_Out = SurgePercentUsed * (._Axis3PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis3DIR3 = True Then
                        Axis3_Value3_Out = Axis3_Value3_Out * -1
                    End If
            End Select
            'BUILD Value

            If ._Axis3DOF1 <> "-" Then
                Axis3_Output = Axis3_Value1_Out
            End If
            If ._Axis3DOF2 <> "-" Then
                Axis3_Output = Axis3_Output + Axis3_Value2_Out
            End If
            If ._Axis3DOF3 <> "-" Then
                Axis3_Output = Axis3_Output + Axis3_Value3_Out
            End If

            'Limmit ouput with axis limiter
            Axis3_Output = Axis3_Output * (GameServer.GetAxisLimiting_Axis3 * 0.01)
            'Set output
            Set_Axis3Output(Axis3_Output)
        End With
        'Reset Needed Vars
        Axis3_Output = 0
        'start a new thread
        Thread.Sleep(CalculateRateMS)
        If Axis_Calulations_Calc = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub
#End Region

#Region "Axis4"
    Private Axis4_Output As Double = 0
    Private Axis4_Value1_Out As Double = 0
    Private Axis4_Value2_Out As Double = 0
    Private Axis4_Value3_Out As Double = 0
    Private Sub Axis4_Calulations()
Start:
        With My_AxisAssignments
            Dim RollPercentUsed As Double = GameServer.GetRollPercent
            Dim PitchPercentUsed As Double = GameServer.GetPitchPercent
            Dim HeavePercentUsed As Double = GameServer.GetHeavePercent
            Dim YawPercentUsed As Double = GameServer.GetYawPercent
            Dim SwayPercentUsed As Double = GameServer.GetSwayPercent
            Dim SurgePercentUsed As Double = GameServer.GetSurgePercent


            'DOF1
            Select Case ._Axis4DOF1
                Case "-"
                    Axis4_Value1_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis4_Value1_Out = RollPercentUsed * (._Axis4PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR1 = True Then
                        Axis4_Value1_Out = Axis4_Value1_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis4_Value1_Out = PitchPercentUsed * (._Axis4PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR1 = True Then
                        Axis4_Value1_Out = Axis4_Value1_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis4_Value1_Out = HeavePercentUsed * (._Axis4PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR1 = True Then
                        Axis4_Value1_Out = Axis4_Value1_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis4_Value1_Out = YawPercentUsed * (._Axis4PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR1 = True Then
                        Axis4_Value1_Out = Axis4_Value1_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis4_Value1_Out = SwayPercentUsed * (._Axis4PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR1 = True Then
                        Axis4_Value1_Out = Axis4_Value1_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis4_Value1_Out = SurgePercentUsed * (._Axis4PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR1 = True Then
                        Axis4_Value1_Out = Axis4_Value1_Out * -1
                    End If
            End Select
            'DOF2
            Select Case ._Axis4DOF2
                Case "-"
                    Axis4_Value2_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis4_Value2_Out = RollPercentUsed * (._Axis4PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR2 = True Then
                        Axis4_Value2_Out = Axis4_Value2_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis4_Value2_Out = PitchPercentUsed * (._Axis4PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR2 = True Then
                        Axis4_Value2_Out = Axis4_Value2_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis4_Value2_Out = HeavePercentUsed * (._Axis4PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR2 = True Then
                        Axis4_Value2_Out = Axis4_Value2_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis4_Value2_Out = YawPercentUsed * (._Axis4PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR2 = True Then
                        Axis4_Value2_Out = Axis4_Value2_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis4_Value2_Out = SwayPercentUsed * (._Axis4PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR2 = True Then
                        Axis4_Value2_Out = Axis4_Value2_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis4_Value2_Out = SurgePercentUsed * (._Axis4PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR2 = True Then
                        Axis4_Value2_Out = Axis4_Value2_Out * -1
                    End If
            End Select
            'DOF3
            Select Case ._Axis4DOF3
                Case "-"
                    Axis4_Value3_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis4_Value3_Out = RollPercentUsed * (._Axis4PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR3 = True Then
                        Axis4_Value3_Out = Axis4_Value3_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis4_Value3_Out = PitchPercentUsed * (._Axis4PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR3 = True Then
                        Axis4_Value3_Out = Axis4_Value3_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis4_Value3_Out = HeavePercentUsed * (._Axis4PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR3 = True Then
                        Axis4_Value3_Out = Axis4_Value3_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis4_Value3_Out = YawPercentUsed * (._Axis4PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR3 = True Then
                        Axis4_Value3_Out = Axis4_Value3_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis4_Value3_Out = SwayPercentUsed * (._Axis4PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR3 = True Then
                        Axis4_Value3_Out = Axis4_Value3_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis4_Value3_Out = SurgePercentUsed * (._Axis4PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis4DIR3 = True Then
                        Axis4_Value3_Out = Axis4_Value3_Out * -1
                    End If
            End Select
            'BUILD Value

            If ._Axis4DOF1 <> "-" Then
                Axis4_Output = Axis4_Value1_Out
            End If
            If ._Axis4DOF2 <> "-" Then
                Axis4_Output = Axis4_Output + Axis4_Value2_Out
            End If
            If ._Axis4DOF3 <> "-" Then
                Axis4_Output = Axis4_Output + Axis4_Value3_Out
            End If

            'Limmit ouput with axis limiter
            Axis4_Output = Axis4_Output * (GameServer.GetAxisLimiting_Axis4 * 0.01)
            'Set output
            Set_Axis4Output(Axis4_Output)

        End With
        'Reset Needed Vars
        Axis4_Output = 0
        'start a new thread
        Thread.Sleep(CalculateRateMS)
        If Axis_Calulations_Calc = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub
#End Region

#Region "Axis5"
    Private Axis5_Output As Double = 0
    Private Axis5_Value1_Out As Double = 0
    Private Axis5_Value2_Out As Double = 0
    Private Axis5_Value3_Out As Double = 0
    Private Sub Axis5_Calulations()
Start:
        With My_AxisAssignments
            Dim RollPercentUsed As Double = GameServer.GetRollPercent
            Dim PitchPercentUsed As Double = GameServer.GetPitchPercent
            Dim HeavePercentUsed As Double = GameServer.GetHeavePercent
            Dim YawPercentUsed As Double = GameServer.GetYawPercent
            Dim SwayPercentUsed As Double = GameServer.GetSwayPercent
            Dim SurgePercentUsed As Double = GameServer.GetSurgePercent


            'DOF1
            Select Case ._Axis5DOF1
                Case "-"
                    Axis5_Value1_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis5_Value1_Out = RollPercentUsed * (._Axis5PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR1 = True Then
                        Axis5_Value1_Out = Axis5_Value1_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis5_Value1_Out = PitchPercentUsed * (._Axis5PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR1 = True Then
                        Axis5_Value1_Out = Axis5_Value1_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis5_Value1_Out = HeavePercentUsed * (._Axis5PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR1 = True Then
                        Axis5_Value1_Out = Axis5_Value1_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis5_Value1_Out = YawPercentUsed * (._Axis5PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR1 = True Then
                        Axis5_Value1_Out = Axis5_Value1_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis5_Value1_Out = SwayPercentUsed * (._Axis5PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR1 = True Then
                        Axis5_Value1_Out = Axis5_Value1_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis5_Value1_Out = SurgePercentUsed * (._Axis5PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR1 = True Then
                        Axis5_Value1_Out = Axis5_Value1_Out * -1
                    End If
            End Select
            'DOF2
            Select Case ._Axis5DOF2
                Case "-"
                    Axis5_Value2_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis5_Value2_Out = RollPercentUsed * (._Axis5PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR2 = True Then
                        Axis5_Value2_Out = Axis5_Value2_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis5_Value2_Out = PitchPercentUsed * (._Axis5PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR2 = True Then
                        Axis5_Value2_Out = Axis5_Value2_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis5_Value2_Out = HeavePercentUsed * (._Axis5PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR2 = True Then
                        Axis5_Value2_Out = Axis5_Value2_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis5_Value2_Out = YawPercentUsed * (._Axis5PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR2 = True Then
                        Axis5_Value2_Out = Axis5_Value2_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis5_Value2_Out = SwayPercentUsed * (._Axis5PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR2 = True Then
                        Axis5_Value2_Out = Axis5_Value2_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis5_Value2_Out = SurgePercentUsed * (._Axis5PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR2 = True Then
                        Axis5_Value2_Out = Axis5_Value2_Out * -1
                    End If
            End Select
            'DOF3
            Select Case ._Axis5DOF3
                Case "-"
                    Axis5_Value3_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis5_Value3_Out = RollPercentUsed * (._Axis5PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR3 = True Then
                        Axis5_Value3_Out = Axis5_Value3_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis5_Value3_Out = PitchPercentUsed * (._Axis5PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR3 = True Then
                        Axis5_Value3_Out = Axis5_Value3_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis5_Value3_Out = HeavePercentUsed * (._Axis5PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR3 = True Then
                        Axis5_Value3_Out = Axis5_Value3_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis5_Value3_Out = YawPercentUsed * (._Axis5PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR3 = True Then
                        Axis5_Value3_Out = Axis5_Value3_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis5_Value3_Out = SwayPercentUsed * (._Axis5PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR3 = True Then
                        Axis5_Value3_Out = Axis5_Value3_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis5_Value3_Out = SurgePercentUsed * (._Axis5PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis5DIR3 = True Then
                        Axis5_Value3_Out = Axis5_Value3_Out * -1
                    End If
            End Select
            'BUILD Value

            If ._Axis5DOF1 <> "-" Then
                Axis5_Output = Axis5_Value1_Out
            End If
            If ._Axis5DOF2 <> "-" Then
                Axis5_Output = Axis5_Output + Axis5_Value2_Out
            End If
            If ._Axis5DOF3 <> "-" Then
                Axis5_Output = Axis5_Output + Axis5_Value3_Out
            End If

            'Limmit ouput with axis limiter
            Axis5_Output = Axis5_Output * (GameServer.GetAxisLimiting_Axis5 * 0.01)
            'Set output
            Set_Axis5Output(Axis5_Output)
        End With
        'Reset Needed Vars
        Axis5_Output = 0
        'start a new thread
        Thread.Sleep(CalculateRateMS)
        If Axis_Calulations_Calc = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub
#End Region

#Region "Axis6"
    Private Axis6_Output As Double = 0
    Private Axis6_Value1_Out As Double = 0
    Private Axis6_Value2_Out As Double = 0
    Private Axis6_Value3_Out As Double = 0
    Private Sub Axis6_Calulations()
Start:
        With My_AxisAssignments
            Dim RollPercentUsed As Double = GameServer.GetRollPercent
            Dim PitchPercentUsed As Double = GameServer.GetPitchPercent
            Dim HeavePercentUsed As Double = GameServer.GetHeavePercent
            Dim YawPercentUsed As Double = GameServer.GetYawPercent
            Dim SwayPercentUsed As Double = GameServer.GetSwayPercent
            Dim SurgePercentUsed As Double = GameServer.GetSurgePercent


            'DOF1
            Select Case ._Axis6DOF1
                Case "-"
                    Axis6_Value1_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis6_Value1_Out = RollPercentUsed * (._Axis6PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR1 = True Then
                        Axis6_Value1_Out = Axis6_Value1_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis6_Value1_Out = PitchPercentUsed * (._Axis6PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR1 = True Then
                        Axis6_Value1_Out = Axis6_Value1_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis6_Value1_Out = HeavePercentUsed * (._Axis6PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR1 = True Then
                        Axis6_Value1_Out = Axis6_Value1_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis6_Value1_Out = YawPercentUsed * (._Axis6PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR1 = True Then
                        Axis6_Value1_Out = Axis6_Value1_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis6_Value1_Out = SwayPercentUsed * (._Axis6PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR1 = True Then
                        Axis6_Value1_Out = Axis6_Value1_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis6_Value1_Out = SurgePercentUsed * (._Axis6PER1 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR1 = True Then
                        Axis6_Value1_Out = Axis6_Value1_Out * -1
                    End If
            End Select
            'DOF2
            Select Case ._Axis6DOF2
                Case "-"
                    Axis6_Value2_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis6_Value2_Out = RollPercentUsed * (._Axis6PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR2 = True Then
                        Axis6_Value2_Out = Axis6_Value2_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis6_Value2_Out = PitchPercentUsed * (._Axis6PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR2 = True Then
                        Axis6_Value2_Out = Axis6_Value2_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis6_Value2_Out = HeavePercentUsed * (._Axis6PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR2 = True Then
                        Axis6_Value2_Out = Axis6_Value2_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis6_Value2_Out = YawPercentUsed * (._Axis6PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR2 = True Then
                        Axis6_Value2_Out = Axis6_Value2_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis6_Value2_Out = SwayPercentUsed * (._Axis6PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR2 = True Then
                        Axis6_Value2_Out = Axis6_Value2_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis6_Value2_Out = SurgePercentUsed * (._Axis6PER2 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR2 = True Then
                        Axis6_Value2_Out = Axis6_Value2_Out * -1
                    End If
            End Select
            'DOF3
            Select Case ._Axis6DOF3
                Case "-"
                    Axis6_Value3_Out = 0
                    Exit Select
                Case "Roll"
                    'Get percent used for DOF
                    Axis6_Value3_Out = RollPercentUsed * (._Axis6PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR3 = True Then
                        Axis6_Value3_Out = Axis6_Value3_Out * -1
                    End If
                Case "Pitch"
                    'Get percent used for DOF
                    Axis6_Value3_Out = PitchPercentUsed * (._Axis6PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR3 = True Then
                        Axis6_Value3_Out = Axis6_Value3_Out * -1
                    End If
                Case "Heave"
                    'Get percent used for DOF
                    Axis6_Value3_Out = HeavePercentUsed * (._Axis6PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR3 = True Then
                        Axis6_Value3_Out = Axis6_Value3_Out * -1
                    End If
                Case "Yaw"
                    'Get percent used for DOF
                    Axis6_Value3_Out = YawPercentUsed * (._Axis6PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR3 = True Then
                        Axis6_Value3_Out = Axis6_Value3_Out * -1
                    End If
                Case "Sway"
                    'Get percent used for DOF
                    Axis6_Value3_Out = SwayPercentUsed * (._Axis6PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR3 = True Then
                        Axis6_Value3_Out = Axis6_Value3_Out * -1
                    End If
                Case "Surge"
                    'Get percent used for DOF
                    Axis6_Value3_Out = SurgePercentUsed * (._Axis6PER3 * 0.01)
                    'Flip if necessary
                    If ._Axis6DIR3 = True Then
                        Axis6_Value3_Out = Axis6_Value3_Out * -1
                    End If
            End Select
            'BUILD Value

            If ._Axis6DOF1 <> "-" Then
                Axis6_Output = Axis6_Value1_Out
            End If
            If ._Axis6DOF2 <> "-" Then
                Axis6_Output = Axis6_Output + Axis6_Value2_Out
            End If
            If ._Axis6DOF3 <> "-" Then
                Axis6_Output = Axis6_Output + Axis6_Value3_Out
            End If

            'Limmit ouput with axis limiter
            Axis6_Output = Axis6_Output * (GameServer.GetAxisLimiting_Axis6 * 0.01)
            'Set output
            Set_Axis6Output(Axis6_Output)
        End With
        'Reset Needed Vars
        Axis6_Output = 0
        'start a new thread
        Thread.Sleep(CalculateRateMS)
        If Axis_Calulations_Calc = True Then
            'Loop
            GoTo Start
        Else
            Exit Sub
        End If
    End Sub
#End Region
#End Region

    Private My_InterfaceAssignments As New NetClient.InterfaceAssignments
    Private My_AxisAssignments As New NetClient.AxisAssignments
    Private Axis1 As Boolean = False
    Private Axis2 As Boolean = False
    Private Axis3 As Boolean = False
    Private Axis4 As Boolean = False
    Private Axis5 As Boolean = False
    Private Axis6 As Boolean = False
    Public Sub StartupSelected()
        Axis1 = False
        Axis2 = False
        Axis3 = False
        Axis4 = False
        Axis5 = False
        Axis6 = False
        Dim Roll As Boolean = False
        Dim Pitch As Boolean = False
        Dim Heave As Boolean = False
        Dim Yaw As Boolean = False
        Dim Sway As Boolean = False
        Dim Surge As Boolean = False

        'Lets see what is used
        My_AxisAssignments = CType(GameServer.GetAxisAssignments, NetClient.AxisAssignments)

        'Get Assignments1
        My_InterfaceAssignments = CType(GameServer.GetInterfaceAssignments1, NetClient.InterfaceAssignments)
        'See if Interface is used
        If My_InterfaceAssignments._ComPort <> "-" Then
            Dim Output As String = My_InterfaceAssignments._InterfaceOutput
            If Output.Contains("<Axis1>") Then
                Axis1 = True
            End If
            If Output.Contains("<Axis2>") Then
                Axis2 = True
            End If
            If Output.Contains("<Axis3>") Then
                Axis3 = True
            End If
            If Output.Contains("<Axis4>") Then
                Axis4 = True
            End If
            If Output.Contains("<Axis5>") Then
                Axis5 = True
            End If
            If Output.Contains("<Axis6>") Then
                Axis6 = True
            End If
        End If

        'Get Assignments2
        My_InterfaceAssignments = CType(GameServer.GetInterfaceAssignments2, NetClient.InterfaceAssignments)
        'See if Interface is used
        If My_InterfaceAssignments._ComPort <> "-" Then
            Dim Output As String = My_InterfaceAssignments._InterfaceOutput
            If Output.Contains("<Axis1>") Then
                Axis1 = True
            End If
            If Output.Contains("<Axis2>") Then
                Axis2 = True
            End If
            If Output.Contains("<Axis3>") Then
                Axis3 = True
            End If
            If Output.Contains("<Axis4>") Then
                Axis4 = True
            End If
            If Output.Contains("<Axis5>") Then
                Axis5 = True
            End If
            If Output.Contains("<Axis6>") Then
                Axis6 = True
            End If
        End If

        'Get Assignments3
        My_InterfaceAssignments = CType(GameServer.GetInterfaceAssignments3, NetClient.InterfaceAssignments)
        'See if Interface is used
        If My_InterfaceAssignments._ComPort <> "-" Then
            Dim Output As String = My_InterfaceAssignments._InterfaceOutput
            If Output.Contains("<Axis1>") Then
                Axis1 = True
            End If
            If Output.Contains("<Axis2>") Then
                Axis2 = True
            End If
            If Output.Contains("<Axis3>") Then
                Axis3 = True
            End If
            If Output.Contains("<Axis4>") Then
                Axis4 = True
            End If
            If Output.Contains("<Axis5>") Then
                Axis5 = True
            End If
            If Output.Contains("<Axis6>") Then
                Axis6 = True
            End If
        End If

        'Get Assignments4
        My_InterfaceAssignments = CType(GameServer.GetInterfaceAssignments4, NetClient.InterfaceAssignments)
        'See if Interface is used
        If My_InterfaceAssignments._ComPort <> "-" Then
            Dim Output As String = My_InterfaceAssignments._InterfaceOutput
            If Output.Contains("<Axis1>") Then
                Axis1 = True
            End If
            If Output.Contains("<Axis2>") Then
                Axis2 = True
            End If
            If Output.Contains("<Axis3>") Then
                Axis3 = True
            End If
            If Output.Contains("<Axis4>") Then
                Axis4 = True
            End If
            If Output.Contains("<Axis5>") Then
                Axis5 = True
            End If
            If Output.Contains("<Axis6>") Then
                Axis6 = True
            End If
        End If

        'Get Assignments5
        My_InterfaceAssignments = CType(GameServer.GetInterfaceAssignments5, NetClient.InterfaceAssignments)
        'See if Interface is used
        If My_InterfaceAssignments._ComPort <> "-" Then
            Dim Output As String = My_InterfaceAssignments._InterfaceOutput
            If Output.Contains("<Axis1>") Then
                Axis1 = True
            End If
            If Output.Contains("<Axis2>") Then
                Axis2 = True
            End If
            If Output.Contains("<Axis3>") Then
                Axis3 = True
            End If
            If Output.Contains("<Axis4>") Then
                Axis4 = True
            End If
            If Output.Contains("<Axis5>") Then
                Axis5 = True
            End If
            If Output.Contains("<Axis6>") Then
                Axis6 = True
            End If
        End If

        'Get Assignments6
        My_InterfaceAssignments = CType(GameServer.GetInterfaceAssignments6, NetClient.InterfaceAssignments)
        'See if Interface is used
        If My_InterfaceAssignments._ComPort <> "-" Then
            Dim Output As String = My_InterfaceAssignments._InterfaceOutput
            If Output.Contains("<Axis1>") Then
                Axis1 = True
            End If
            If Output.Contains("<Axis2>") Then
                Axis2 = True
            End If
            If Output.Contains("<Axis3>") Then
                Axis3 = True
            End If
            If Output.Contains("<Axis4>") Then
                Axis4 = True
            End If
            If Output.Contains("<Axis5>") Then
                Axis5 = True
            End If
            If Output.Contains("<Axis6>") Then
                Axis6 = True
            End If
        End If

        'Now we know what AXIS output are used ###############################################
        'Now we need what DOF's to start
        If Axis1 = True Then
            Select Case My_AxisAssignments._Axis1DOF1
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis1DOF2
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis1DOF3
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
        End If
        If Axis2 = True Then
            Select Case My_AxisAssignments._Axis2DOF1
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis2DOF2
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis2DOF3
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
        End If
        If Axis3 = True Then
            Select Case My_AxisAssignments._Axis3DOF1
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis3DOF2
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis3DOF3
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
        End If
        If Axis4 = True Then
            Select Case My_AxisAssignments._Axis4DOF1
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis4DOF2
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis4DOF3
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
        End If
        If Axis5 = True Then
            Select Case My_AxisAssignments._Axis5DOF1
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis5DOF2
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis5DOF3
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
        End If
        If Axis6 = True Then
            Select Case My_AxisAssignments._Axis6DOF1
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis6DOF2
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
            Select Case My_AxisAssignments._Axis6DOF3
                Case "Roll"
                    Roll = True
                Case "Pitch"
                    Pitch = True
                Case "Heave"
                    Heave = True
                Case "Yaw"
                    Yaw = True
                Case "Sway"
                    Sway = True
                Case "Surge"
                    Surge = True
            End Select
        End If

        'Lets startup selected
        'DOFs
        If Roll = True Or Pitch = True Or Heave = True Or Yaw = True Or Sway = True Or Surge = True Then
            Calc_Percent_IsRunning = True
        End If
        If Roll = True Then
            Calculate_Roll_Percent_ON()
        End If
        If Pitch = True Then
            Calculate_Pitch_Percent_ON()
        End If
        If Heave = True Then
            Calculate_Heave_Percent_ON()
        End If
        If Yaw = True Then
            Calculate_Yaw_Percent_ON()
        End If
        If Sway = True Then
            Calculate_Sway_Percent_ON()
        End If
        If Surge = True Then
            Calculate_Surge_Percent_ON()
        End If

        'AXIS
        If Axis1 = True Or Axis2 = True Or Axis3 = True Or Axis4 = True Or Axis5 = True Or Axis6 = True Then
            Axis_Calulations_Calc = True
        End If
        If Axis1 = True Then
            'Axis 1
            Dim trd1 As Thread = New Thread(AddressOf Axis1_Calulations)
            trd1.IsBackground = True
            trd1.Start()
        End If
        If Axis2 = True Then
            'Axis 2
            Dim trd2 As Thread = New Thread(AddressOf Axis2_Calulations)
            trd2.IsBackground = True
            trd2.Start()
        End If
        If Axis3 = True Then
            'Axis 3
            Dim trd3 As Thread = New Thread(AddressOf Axis3_Calulations)
            trd3.IsBackground = True
            trd3.Start()
        End If
        If Axis4 = True Then
            'Axis 4
            Dim trd4 As Thread = New Thread(AddressOf Axis4_Calulations)
            trd4.IsBackground = True
            trd4.Start()
        End If
        If Axis5 = True Then
            'Axis 5
            Dim trd5 As Thread = New Thread(AddressOf Axis5_Calulations)
            trd5.IsBackground = True
            trd5.Start()
        End If
        If Axis6 = True Then
            'Axis 6
            Dim trd6 As Thread = New Thread(AddressOf Axis6_Calulations)
            trd6.IsBackground = True
            trd6.Start()
        End If
    End Sub
End Module
