﻿Option Explicit On
Option Strict On

Imports System.Net.Sockets
Imports System.Text
Imports System.Net
Imports System.Threading
Imports System.Runtime.InteropServices
Imports System.Math

Module Mod_OutSim
    Private ReceivingUdpClient As UdpClient
    Private RemoteIpEndPoint As New IPEndPoint(System.Net.IPAddress.Any, 0)
    Private ThreadReceive As Thread
    Private MyOutsim_Internal As New OutSim
    Private MyPort As Integer = 4123
    Private OutSimStarted As Boolean = False

    Sub Stop_OutSim_Listener()
        Try
            OutSimStarted = False
            ThreadReceive.Abort()
            ReceivingUdpClient.Close()
        Catch ex As Exception
            OutSimStarted = False
        End Try
    End Sub

    Sub Start_OutSim_Listener()
        OutSimStarted = True
        ReceivingUdpClient = New UdpClient(MyPort)
        ThreadReceive = New Thread(AddressOf ReceiveMessages)
        ThreadReceive.IsBackground = True
        ThreadReceive.Start()
    End Sub

    Private Sub ReceiveMessages()
       Try
            If OutSimStarted = True Then
                'set an IP - we are using ALL IP's
                Dim receiveBytes As [Byte]() = ReceivingUdpClient.Receive(RemoteIpEndPoint)
                'get message string
                Dim MessageRecieved As String = System.Text.Encoding.Default.GetString(receiveBytes)
                'Convert string to byte and copy to byte array
                Dim ByteArray() As Byte = Encoding.Default.GetBytes(MessageRecieved)
                'Create Gchandle instance and pin variable required
                Dim MyGC As GCHandle = GCHandle.Alloc(MyOutsim_Internal, GCHandleType.Pinned)
                'get address of variable in pointer variable
                Dim AddofLongValue As IntPtr = MyGC.AddrOfPinnedObject()
                'Copy the memory space to my GCHandle
                Marshal.Copy(ByteArray, 0, AddofLongValue, ByteArray.Length)
                'Direct Cast myGC to my Outsim Object
                MyOutsim_Internal = DirectCast(MyGC.Target, OutSim)
                'Free GChandle to avoid memory leaks
                MyGC.Free()

                'Get Proper Data out of UDP Packet
                With MyOutsim_Internal
                    GameServer.SetRoll(((Cos(.sngOrientation0) * .sngAcceleration0) + (Sin(.sngOrientation0) * .sngAcceleration1)) * -1)
                    GameServer.SetPitch(((-Sin(.sngOrientation0) * .sngAcceleration0) + (Cos(.sngOrientation0) * .sngAcceleration1)) * -1)
                    GameServer.SetHeave(.sngAcceleration2)
                    GameServer.SetYaw(((Sin(.sngOrientation0) * .sngAcceleration0) + (Sin(.sngOrientation0) * .sngAcceleration1)) * -1)
                    GameServer.SetSway(.sngAcceleration0)
                    GameServer.SetSurge(.sngAcceleration1)
                End With
                'Start New Thread
                ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
                ThreadReceive.IsBackground = True
                ThreadReceive.Start()
                Exit Sub
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Structure OutSim
        '   time in milliseconds
        Public bytTime1 As Byte
        Public bytTime2 As Byte
        Public bytTime3 As Byte
        Public bytTime4 As Byte
        '   Angular Velocity
        Public sngAVelocity0 As Single
        Public sngAVelocity1 As Single
        Public sngAVelocity2 As Single
        '   Orientation
        Public sngOrientation0 As Single
        Public sngOrientation1 As Single
        Public sngOrientation2 As Single
        '   Acceleration 
        Public sngAcceleration0 As Single
        Public sngAcceleration1 As Single
        Public sngAcceleration2 As Single
        '   Velocity
        Public sngVelocity0 As Single
        Public sngVelocity1 As Single
        Public sngVelocity2 As Single
        '   Position
        Public bytPosition01 As Byte
        Public bytPosition02 As Byte
        Public bytPosition03 As Byte
        Public bytPosition04 As Byte
        Public bytPosition11 As Byte
        Public bytPosition12 As Byte
        Public bytPosition13 As Byte
        Public bytPosition14 As Byte
        Public bytPosition21 As Byte
        Public bytPosition22 As Byte
        Public bytPosition23 As Byte
        Public bytPosition24 As Byte
        '   Game ID - if specified in cfg.txt
        Public lngGameID As Long
    End Structure
End Module
