﻿Option Explicit On
Option Strict On

Imports System.Threading
Imports System.Net.Sockets
Imports System.Net
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Xml.Serialization
Imports System.IO

Module Mod_SimBin
    Private ReceivingUdpClient As UdpClient
    Private RemoteIpEndPoint As New IPEndPoint(System.Net.IPAddress.Any, 0)
    Private ThreadReceive As Thread
    Private Input_Data As New NetClient.GenericOutput
    Private MyPort As Integer = 65523
    Private SimBinStarted As Boolean = False

    Public Sub Stop_SimBin_Listener()
        Try
            SimBinStarted = False
            ThreadReceive.Abort()
            ReceivingUdpClient.Close()
        Catch ex As Exception
            SimBinStarted = False
        End Try
    End Sub

    Public Sub Start_SimBin_Listener()
        SimBinStarted = True
        ReceivingUdpClient = New UdpClient(MyPort)
        RemoteIpEndPoint.Address = System.Net.IPAddress.Any
        RemoteIpEndPoint.Port = MyPort
        ThreadReceive = New Thread(AddressOf ReceiveMessages)
        ThreadReceive.IsBackground = True
        ThreadReceive.Start()
    End Sub

    Private Serialiver As New NetClient
    Private Sub ReceiveMessages()
        Try
            If SimBinStarted = True Then
                Dim receiveBytes As [Byte]() = ReceivingUdpClient.Receive(RemoteIpEndPoint)
                'get message
                Dim Message As String = System.Text.Encoding.ASCII.GetString(receiveBytes)
                Input_Data = CType(Serialiver.DeSerializeString(Message, "GenericOutput"), NetClient.GenericOutput)
                'Get Proper Data out of UDP Packet
                With Input_Data
                    GameServer.SetRoll(.Roll)
                    GameServer.SetPitch(.Pitch)
                    GameServer.SetHeave(.Heave)
                    GameServer.SetYaw(0)
                    GameServer.SetSway(0)
                    GameServer.SetSurge(0)
                End With
                'Start New Thread
                ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
                ThreadReceive.IsBackground = True
                ThreadReceive.Start()
                Exit Sub
            End If
        Catch ex As Exception
        End Try
    End Sub
End Module
